import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * @version 4, Oct 10
 * In this version, the Counter still holds an int counter, but in order to
 * protect this counter from unauthorized access, the variable is now private
 * and there is no public "increment" method; instead, Counter provides an
 * incrementer object, which (in practice) is an instance of an inner class.
 */
public class Counter
{
    private int current = 0;
    private CounterIncrementer incr;
    
    public Counter ()
    {
        this.incr = new CounterIncrementer();
    }

    public ActionListener getIncrementer ()
    {
        return this.incr;
    }


    
    class CounterIncrementer implements ActionListener
    {


        public void actionPerformed (ActionEvent e)
        {
            Counter.this.current++;
            System.out.println ("Counter is " + Counter.this.current);
        }
    }
}
